#ifndef _KDWINDOW_H
#define _KDWINDOW_H
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include "LODRect.h"
#include "LODRectList.h"

#define KD_MAX_WINDOW 20

#define ST_NONE 0
#define ST_BREAKGAME 1

// ϥɥ顼롼Υ٥ȥ
#define KD_EV_NONE   (-1)
#define KD_EV_INIT   0
#define KD_EV_KEY    1
#define KD_EV_MOUSE  2
#define KD_EV_EXPOSE 3
#define KD_EV_TIMER  4
#define KD_EV_END    5
#define KD_EV_RETURN 6
#define KD_EV_USER   7


extern Pixmap stage_pm;  // ơ
extern Display* dis;  // Default Display
extern int scr;  // Default Screen
extern Window rootwin;
extern int screen_depth;  // screen depth
extern GC gc;  // utility gc

class KdWindow {
protected:
	static KdWindow* del_queue[KD_MAX_WINDOW];
	static int q_r, q_w;
	static KdWindow* wins[KD_MAX_WINDOW];
	static int win_count;
public:
	static Window win;  // for X

	static int add_window(KdWindow* win);
	static int close_window(KdWindow* win);
	static int ret_window(KdWindow* win, int rint, void* ret);
	static void set_clip(GC gc, LODRectList* l);
	static void get_clip(KdWindow* win, LODRectList** l);
	static int exec_event(int flag, void* vp);
	static void redraw();

	KdWindow* parent;

	KdWindow(KdWindow* _parent) { parent = _parent; }
	virtual ~KdWindow() {}
	virtual void get_rect(LODRect* rect);
	virtual int init();
	virtual int mouse(int x, int y);
	virtual int key(KeySym sym);
	virtual int paint(LODRectList* rl);
	virtual int timer();
	virtual int ret(KdWindow* src, int rint, void* ret);
	virtual int end();
};


#endif
