#include <stdio.h>
#include "LODRectList.h"

/*
========================================================================
ǽ: Υ쥯󥰥ɲä
: r = 쥯󥰥
: ʤ
­: ˤϰڹθʤ
========================================================================
*/
void
LODRectList::add(LODRect* r)
{
    add(r->left, r->top, r->right, r->bottom);
}


/*
========================================================================
ǽ: Υ쥯󥰥ɲä
: (l, t, r, b) = 쥯󥰥
: ʤ
­: ˤϰڹθʤ
========================================================================
*/
void
LODRectList::add(int l, int t, int r, int b)
{
    int i;

    if (l==r || t==b) return;  // NULL rectä
    if (l > r) {
        i = l;
        l = r;
        r = i;
    }
    if (t > b) {
        i = t;
        t = b;
        b = i;
    }
    if (count==allocates) {
        LODRect** new_rects;
        allocates += 50;
        new_rects = new LODRect*[allocates];
        for(i=0; i<count; i++) {
            new_rects[i] = new LODRect(rects[i]);
            delete rects[i];
        }
        if (rects) delete rects;
        rects = new_rects;
    }
    rects[count++] = new LODRect(l, t, r, b);
}


/*
========================================================================
ǽ: Υ쥯󥰥ꥹȤɲä
: dst = 쥯󥰥ꥹ
: ʤ
­: ˤϰڹθʤ
========================================================================
*/
void
LODRectList::add(LODRectList* dst)
{
    int i;
    for(i=0; i<dst->count; i++) {
        add(dst->rects[i]);
    }
}


/*
========================================================================
ǽ: Υ쥯󥰥ƱͤΥ쥯󥰥õ
: r = ä쥯󥰥
: ʤ
­:
========================================================================
*/
void
LODRectList::del(LODRect* r)
{
    int i, j;
    LODRect* rd;

    for(i=0; i<count; i++) {
        if (rects[i]->top==r->top && rects[i]->right==r->right
            && rects[i]->left==r->left && rects[i]->bottom==r->bottom) {
            rd = rects[i];
            for(j=i+1; j<count; j++) {
                rects[j-1] = rects[j];
            }
            delete rd;
            count--;
        }
    }
}


/*
========================================================================
ǽ: Υ쥯󥰥ꥹȤƤ򥳥ԡ
: dst = 쥯󥰥ꥹ
: ʤ
­:
========================================================================
*/
void
LODRectList::copy(LODRectList* dst)
{
    int i;

	purge();
    for(i=0; i<dst->count; i++) {
        add(dst->rects[i]);
    }
}


/*
========================================================================
ǽ: դ
: ʤ
: ʤ
­: 
========================================================================
*/
void
LODRectList::purge()
{
	int i;
    for(i=0; i<count; i++) {
        delete rects[i];
    }
    if (rects) delete rects;
    rects = NULL;
    allocates = count = 0;
}


/*
========================================================================
ǽ: Υ쥯󥰥ꥹȤƤưư
: r = 쥯󥰥ꥹ
: ʤ
­: оݤΥ쥯󥰥ꥹȤ϶ˤʤ
========================================================================
*/
void
LODRectList::move(LODRectList* r)
{
	purge();
	rects = r->rects;
	allocates = r->allocates;
	count = r->count;
	r->count = r->allocates = 0;
	r->rects = NULL;
}


/*
========================================================================
ǽ: Υ쥯󥰥ܹǽʥ쥯󥰥뤬ܹ礹
: r = 쥯󥰥
: 0:ܹ礷ʤä 1:ܹ礷
­: 
========================================================================
*/
int
LODRectList::union_rect(LODRect* r)
{
    int i;

    for(i=0; i<count; i++) {
        if (rects[i]->top==r->top
            && rects[i]->bottom==r->bottom
            && rects[i]->left==r->right) {
            // ܹ
            rects[i]->left = r->left;
            return 1;
        }
        else if (rects[i]->top==r->top
            && rects[i]->bottom==r->bottom
            && rects[i]->right==r->left) {
            // ܹ
            rects[i]->right = r->right;
            return 1;
        }
        else if (rects[i]->right==r->right
                 && rects[i]->left==r->left
                 && rects[i]->bottom==r->top) {
            // ܹ
            rects[i]->bottom = r->bottom;
            return 1;
        }
        else if (rects[i]->right==r->right
                 && rects[i]->left==r->left
                 && rects[i]->top==r->bottom) {
            // ܹ
            rects[i]->top = r->top;
            return 1;
        }
    }
    return 0;
}


/*
========================================================================
ǽ: Υ쥯󥰥ܤƤyڤľɬפн
: r = 쥯󥰥
: 0:оݤȤʤ쥯󥰥뤬̵ä 1:ä
­: ɤȤäƸ

     +-------+
     |       +-+
	 |  	 | |
	 +-------+-+

	 Τ褦ܤƤ쥯󥰥ϡ

	 +-------+
	 +-------+-+
	 |         |
	 +---------+

	 ȤڤľȤ
========================================================================
*/
int
LODRectList::y_order_rect(LODRect* r)
{
    int i, j, f;

    LODRectList* new_list;

    new_list = new LODRectList;
    f = 0;
    for(i=0; i<count; i++) {
        if (rects[i]->contact(r)==0) {
            new_list->add(rects[i]);
            continue;
        }
        if (rects[i]->can_union(r)) {
            new_list->add(rects[i]);
            continue;  // äƤƤ
        }
        // ܤƤ
        if (rects[i]->right==r->left
            && rects[i]->top <= r->top
            && r->top < rects[i]->bottom
            && rects[i]->top <= r->bottom
            && r->bottom < rects[i]->bottom) {
            // ܤƤ()
            new_list->add(rects[i]->left, rects[i]->top,
                          rects[i]->right, r->top);
            new_list->add(rects[i]->left, r->top,
                          r->right, r->bottom);
            new_list->add(rects[i]->left, r->bottom,
                          rects[i]->right, rects[i]->bottom);
            f = 1;
        }
        else if (rects[i]->left==r->right
                 && rects[i]->top <= r->top
                 && r->top < rects[i]->bottom
                 && rects[i]->top <= r->bottom
                 && r->bottom < rects[i]->bottom) {
            // ܤƤ()
            new_list->add(rects[i]->left, rects[i]->top,
                          rects[i]->right, r->top);
            new_list->add(r->left, r->top,
                          rects[i]->right, r->bottom);
            new_list->add(rects[i]->left, r->bottom,
                          rects[i]->right, rects[i]->bottom);
            f = 1;
        }
        else if (rects[i]->right==r->left
                 && r->top <= rects[i]->top
                 && rects[i]->top < r->bottom
                 && r->top <= rects[i]->bottom
                 && rects[i]->bottom < r->bottom) {
            // ܤƤ(礭)
            new_list->add(r->left, r->top,
                          r->right, rects[i]->top);
            new_list->add(rects[i]->left, rects[i]->top,
                          r->right, rects[i]->bottom);
            new_list->add(r->left, rects[i]->bottom,
                          r->right, r->bottom);
            f = 1;
        }
        else if (rects[i]->left==r->right
                 && r->top <= rects[i]->top
                 && rects[i]->top < r->bottom
                 && r->top <= rects[i]->bottom
                 && rects[i]->bottom < r->bottom) {
            // ܤƤ(礭)
            new_list->add(r->left, r->top,
                          r->right, rects[i]->top);
            new_list->add(r->left, rects[i]->top,
                          rects[i]->right, rects[i]->bottom);
            new_list->add(r->left, rects[i]->bottom,
                          r->right, r->bottom);
            f = 1;
        }
        else if (rects[i]->right==r->left &&
                 rects[i]->top<=r->top && r->top < rects[i]->bottom) {
            // ܤƤ
//            puts("koko rd");
            new_list->add(rects[i]->left, rects[i]->top,
                          rects[i]->right, r->top);
            new_list->add(rects[i]->left, r->top,
                          r->right, rects[i]->bottom);
            new_list->add(r->left, rects[i]->bottom,
                          r->right, r->bottom);
            f = 1;
        }
        else if (rects[i]->left==r->right &&
                 rects[i]->top<=r->top && r->top < rects[i]->bottom) {
            // 
//            puts("koko ld");
            new_list->add(rects[i]->left, rects[i]->top,
                          rects[i]->right, r->top);
            new_list->add(r->left, r->top,
                          rects[i]->right, rects[i]->bottom);
            new_list->add(r->left, rects[i]->bottom,
                          r->right, r->bottom);
            f = 1;
        }
        else if (rects[i]->right==r->left &&
                 rects[i]->top<=r->bottom && r->bottom < rects[i]->bottom) {
            // ܤƤ
//            puts("koko ru");
            new_list->add(r->left, r->top, r->right, rects[i]->top);
            new_list->add(rects[i]->left, rects[i]->top, r->right, r->bottom);
            new_list->add(rects[i]->left, r->bottom,
                          rects[i]->right, rects[i]->bottom);
            f = 1;
        }
        else if (rects[i]->left==r->right &&
                 rects[i]->top<=r->bottom && r->bottom < rects[i]->bottom) {
            // 
//            puts("koko lu");
            new_list->add(r->left, r->top, r->right, rects[i]->top);
            new_list->add(r->left, rects[i]->top, rects[i]->right, r->bottom);
            new_list->add(rects[i]->left, r->bottom,
                          rects[i]->right, rects[i]->bottom);
            f = 1;
        }
        else {
            new_list->add(rects[i]);
        }
        if (f) {
            for(j=i+1; j<count; j++) {
                new_list->add(rects[j]);
            }
            move(new_list);
            delete new_list;
            return 1;
        }
    }
    move(new_list);
    delete new_list;
    return 0;
}


/*
========================================================================
ǽ: Υ쥯󥰥ޡ
: r = 쥯󥰥
: 0: ζѹդݤƤ 1: refresh()ɬפ
­: ֤ͤϤޤ굤ˤƤϤʤ
========================================================================
*/
int
LODRectList::merge_rect(LODRect* r)
{
    int i, j, f, ret;
    LODRectList* new_list;

    if (count==0) {
        add(r);
        return 0;
    }
//	puts("here! 1");
    for(i=0; i<count; i++) {
        if (rects[i]->include(r)) {  // ޤǤн
            return 0;
        }
    }
//	puts("here! 2");
    ret = 0;
    do {
        f = 0;
        for(i=0; i<count; i++) {
            if (r->include(rects[i])) {
                del(rects[i]);
                f = 1;
                break;
            }
        }
    } while(f);
    if (count==0) {
        // rޤޤƤ
        add(r);
        return 0;
    }
//	puts("here! 3");
    for(i=0; i<count; i++) {
        if (rects[i]->include(r->left, r->bottom-1)
            &&
            rects[i]->include(r->right-1, r->bottom-1)) {
            // Ǹ
            r->bottom = rects[i]->top;
        }
        else if (rects[i]->include(r->left, r->top)
                 &&
                 rects[i]->include(r->right-1, r->top)) {
            // Ǹ
            r->top = rects[i]->bottom;
        }
        else if (rects[i]->include(r->left, r->top)
                 &&
                 rects[i]->include(r->left, r->bottom-1)) {
            // Ǹ
            r->left = rects[i]->right;
        }
        else if (rects[i]->include(r->right-1, r->top)
                 &&
                 rects[i]->include(r->right-1, r->bottom-1)) {
            // Ǹ
            r->right = rects[i]->left;
        }
        if (r->is_null()) {
            return 0;  // ޤޤƤ
        }
    }
//	puts("here! 4");
    for(i=0; i<count; i++) {
        if (r->include(rects[i]->left, rects[i]->bottom-1)
            &&
            r->include(rects[i]->right-1, rects[i]->bottom-1)) {
            // Ǹ
            rects[i]->bottom = r->top;
            ret = 1;
        }
        else if (r->include(rects[i]->left, rects[i]->top)
                 &&
                 r->include(rects[i]->right-1, rects[i]->top)) {
            // Ǹ
            rects[i]->top = r->bottom;
            ret = 1;
        }
        else if (r->include(rects[i]->left, rects[i]->top)
                 &&
                 r->include(rects[i]->left, rects[i]->bottom-1)) {
            // Ǹ
            rects[i]->left = r->right;
            ret = 1;
        }
        else if (r->include(rects[i]->right-1, rects[i]->top)
                 &&
                 r->include(rects[i]->right-1, rects[i]->bottom-1)) {
            // Ǹ
            rects[i]->right = r->left;
            ret = 1;
        }
    }
//	puts("here! 5");
    f = 0;
    new_list = new LODRectList();
    for(i=0; i<count; i++) {
        if (rects[i]->intersect(r)==0) {
            // 󤼤طʤ
            new_list->add(rects[i]);
        } else {
//			puts("here!");
            if (rects[i]->include(r->left, r->top)) {
                // ޤΤʬ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(rects[i]->left, r->top,
                              r->right, rects[i]->bottom);
                new_list->add(r->left, rects[i]->bottom,
                              r->right, r->bottom);
                f = 1;
//				puts("koko 4");
            }
            else if (rects[i]->include(r->right-1, r->top)) {
                // ޤΤʬ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(r->left, r->top,
                              rects[i]->right, rects[i]->bottom);
                new_list->add(r->left, rects[i]->bottom,
                              r->right, r->bottom);
                f = 1;
//				puts("koko 5");
            }
            else if (rects[i]->include(r->left, r->bottom-1)) {
                // ޤΤʬ
                new_list->add(r->left, r->top,
                              r->right, rects[i]->top);
                new_list->add(rects[i]->left, rects[i]->top,
                              r->right, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
                f = 1;
//				puts("koko 6");
            }
            else if (rects[i]->include(r->right-1, r->bottom-1)) {
                // ޤΤʬ
                new_list->add(r->left, r->top,
                              r->right, rects[i]->top);
                new_list->add(r->left, rects[i]->top,
                              rects[i]->right, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
                f = 1;
//				puts("koko 7");
            }
			else if (rects[i]->top <= r->top
					 && r->top < rects[i]->bottom
					 && rects[i]->top <=r->bottom
					 && r->bottom < rects[i]->bottom) {
				// 
//				puts("koko1");
				new_list->add(rects[i]->left, rects[i]->top,
							  rects[i]->right, r->top);
				new_list->add(r);
				new_list->add(rects[i]->left, r->bottom,
							  rects[i]->right, rects[i]->bottom);
				f = 1;
			}
			else if (rects[i]->left <= r->left
					 && r->left < rects[i]->right
					 && rects[i]->left <= r->right
					 && r->right < rects[i]->right) {
				// 
//				puts("koko2");
				new_list->add(r->left, r->top, r->right, rects[i]->top);
				new_list->add(rects[i]);
				new_list->add(r->left, rects[i]->bottom,
							  r->right, r->bottom);
				f = 1;
			}
			else {
//				puts("koko3");
			}
        }
        if (f) {
            for(j=i+1; j<count; j++) {
                new_list->add(rects[j]);
            }
            move(new_list);
            delete new_list;
            return 1;
        }
    }
    new_list->add(r);
    move(new_list);
    delete new_list;
    return ret;
}


/*
========================================================================
ǽ: RectListǤδĤ褹
: ʤ
: ʤ
­: RectListintersectʤʤޤmerge_rect򤫤
      ˲ǽʸ¤礷y_orderʤ褦ˤ
========================================================================
*/
void
LODRectList::refresh()
{
    int f, i, j, st;
    LODRect r;

    do {
//		dump();
        f = 0;
        for(i=0; i<count; i++) {
            for(j=0; j<count; j++) {
                if (i==j) continue;
                if (rects[i]->intersect(rects[j])) {
					printf("intersect %d %d\n", i, j);
                    r.copy(rects[i]);
                    del(rects[i]);
                    st = merge_rect(&r);
                    f = 1;
                    break;
                }
            }
            if (f) break;
        }
    } while (f);
//	puts("merge");
//	dump();

    do {
        st = 0;
        do {
            f = 0;
            for(i=0; i<count; i++) {
                for(j=0; j<count; j++) {
                    if (i==j) continue;
                    if (rects[i]->can_union(rects[j])) {
                        r.copy(rects[i]);
                        del(rects[i]);
                        st = union_rect(&r);
                        f = 1;
                        st = 1;
                        break;
                    }
                }
                if (f) break;
            }
        } while(f);
//		puts("unite");
//		dump();


        do {
            f = 0;
            for(i=0; i<count; i++) {
                for(j=0; j<count; j++) {
                    if (i==j) continue;
                    if (rects[i]->need_change_y_order(rects[j])) {
                        r.copy(rects[i]);
                        del(rects[i]);
                        st = y_order_rect(&r);
                        f = 1;
                        st = 1;
                        break;
                    }
                }
                if (f) break;
            }
        } while(f);
//		puts("y_order");
//		dump();
    } while (st);
}


/*
========================================================================
ǽ: Υ쥯󥰥ޡ
: r = 쥯󥰥
: ʤ
­: 롼
========================================================================
*/
void
LODRectList::merge(LODRect* r)
{
    add(r);
    refresh();
}


/*
========================================================================
ǽ: Υ쥯󥰥ꥹȤޡ
: dst = 쥯󥰥ꥹ
: ʤ
­: 롼
========================================================================
*/
void
LODRectList::merge(LODRectList* dst)
{
    add(dst);
    refresh();
}


/*
========================================================================
ǽ: Υ쥯󥰥ꥹȤȴ
: r = 쥯󥰥
: ʤ
­: ȴפȤΤϤΥ쥯󥰥ȽŤʤΰ褬̵褦ˤȤ
      ȡ
========================================================================
*/
void
LODRectList::remove_rect(LODRect* r)
{
    int i, f;
    LODRectList* new_list;

	if (r->is_null()) return;
    f = 0;
    for(i=0; i<count; i++) {
        if (rects[i]->intersect(r)) {
            f = 1;
            break;
        }
    }
    if (f==0) return;  // ⤹ɬפ̵
    do {
        f = 0;
        new_list = new LODRectList();
        refresh();
        for(i=0; i<count; i++) {
			if (rects[i]->intersect(r)==0) {
				new_list->add(rects[i]);
				continue;
			}
            if (r->include(rects[i])) {
                // õ쥯󥰥뤬ޤ
//				puts("here! 1");
                f = 1;
            }
            else if (rects[i]->include(r)) {
                // õ쥯󥰥ޤ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(rects[i]->left, r->top,
                              r->left, r->bottom);
                new_list->add(r->right, r->top,
                              rects[i]->right, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 2");
                f = 1;
            }
            else if (rects[i]->include(r->left, r->bottom-1)
                     &&
                     rects[i]->include(r->right-1, r->bottom-1)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              r->left, r->bottom);
                new_list->add(r->right, rects[i]->top,
                              rects[i]->right, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 3");
                f = 1;
            }
            else if (rects[i]->include(r->left, r->top)
                     &&
                     rects[i]->include(r->right-1, r->top)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(rects[i]->left, r->top,
                              r->left, rects[i]->bottom);
                new_list->add(r->right, r->top,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 4");
                f = 1;
            }
            else if (rects[i]->include(r->left, r->top)
                     &&
                     rects[i]->include(r->left, r->bottom-1)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(rects[i]->left, r->top,
                              r->left, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 5");
                f = 1;
            }
            else if (rects[i]->include(r->right-1, r->top)
                     &&
                     rects[i]->include(r->right-1, r->bottom-1)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(r->right, r->top,
                              rects[i]->right, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 6");
                f = 1;
            }
            else if (r->include(rects[i]->left, rects[i]->bottom-1)
                     &&
                     r->include(rects[i]->right-1, rects[i]->bottom-1)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
//				puts("here! 7");
                f = 1;
            }
            else if (r->include(rects[i]->left, rects[i]->top)
                     &&
                     r->include(rects[i]->right-1, rects[i]->top)) {
                // Ǹ
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 8");
                f = 1;
            }
            else if (r->include(rects[i]->left, rects[i]->top)
                     &&
                     r->include(rects[i]->left, rects[i]->bottom-1)) {
                // Ǹ
                new_list->add(r->right, rects[i]->top,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 9");
                f = 1;
            }
            else if (r->include(rects[i]->right-1, rects[i]->top)
                     &&
                     r->include(rects[i]->right-1, rects[i]->bottom-1)) {
                // Ǹ
                new_list->add(rects[i]->left, rects[i]->top,
                              r->left, rects[i]->bottom);
//				puts("here! 10");
                f = 1;
            }
            else if (rects[i]->include(r->left, r->top)) {
                // ޤΤʬ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(rects[i]->left, r->top,
                              r->left, rects[i]->bottom);

//				puts("here! 11");
                f = 1;
            }
            else if (rects[i]->include(r->right-1, r->top)) {
                // ޤΤʬ
                new_list->add(rects[i]->left, rects[i]->top,
                              rects[i]->right, r->top);
                new_list->add(r->right, r->top,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 12");
                f = 1;
            }
            else if (rects[i]->include(r->left, r->bottom-1)) {
                // ޤΤʬ
                new_list->add(rects[i]->left, rects[i]->top,
                              r->left, r->bottom);
                new_list->add(rects[i]->left, r->bottom,
                              rects[i]->right, rects[i]->bottom);
//				puts("here! 13");
                f = 1;
            }
            else if (rects[i]->include(r->right-1, r->bottom-1)) {
                // ޤΤʬ
                new_list->add(r->right, rects[i]->top,
                              rects[i]->right, r->bottom);
                new_list->add(rects[i]->right, r->bottom,
                              rects[i]->left, rects[i]->bottom);
//				puts("here! 14");
                f = 1;
            }
			else if (rects[i]->top <= r->top
					 && r->top < rects[i]->bottom
					 && rects[i]->top <= r->bottom
					 && r->bottom < rects[i]->bottom) {
				// 
				new_list->add(rects[i]->left, rects[i]->top,
							  rects[i]->right, r->top);
				new_list->add(rects[i]->left, r->bottom,
							  rects[i]->right, rects[i]->bottom);
//				puts("here! 15");
				f = 1;
			}
			else if (rects[i]->left <= r->left
					 && r->left < rects[i]->right
					 && rects[i]->left <= r->right
					 && r->right < rects[i]->right) {
				// 
				new_list->add(rects[i]->left, rects[i]->top,
							  r->left, rects[i]->bottom);
				new_list->add(r->right, rects[i]->top,
							  rects[i]->right, rects[i]->bottom);
//				puts("here! 16");
				f = 1;
			}
			else {
				new_list->add(rects[i]);
			}
        }
        move(new_list);
        delete new_list;
    } while (f);
}


/*
========================================================================
ǽ: ǥХåѥ
: ʤ
: ʤ
­: 
========================================================================
*/
void
LODRectList::dump()
{
    int i;

    printf("count=%d\n", count);
    for(i=0; i<count; i++) {
		rects[i]->dump();
    }
}

#if 0
void
main(void)
{
    LODRect *a, *b;
    LODRectList *l;

	puts("merge");
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -1, 3, 1);
	l->merge(b);
	l->dump();
    delete a;
    delete b;
    delete l;
	
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-1, -3, 1, 3);
	l->merge(b);
	l->dump();
    delete a;
    delete b;
    delete l;

	puts("remove");
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-1, -1, 1, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-1, -1, 1, 1);
    l->add(a);
    b = new LODRect(-2, -2, 2, 2);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -3, -1, -1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(3, -3, 1, -1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, 3, -1, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(3, 3, 1, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-1, -3, 1, -1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

	puts("--");
	
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(1, -1, 3, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-1, 1, 1, 3);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -1, -1, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

	// cover
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -3, 3, -1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(1, -3, 3, 3);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, 1, 3, 3);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -3, -1, 3);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

	// cross
    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-3, -1, 3, 1);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;

    l = new LODRectList();
    a = new LODRect(-2, -2, 2, 2);
    l->add(a);
    b = new LODRect(-1, -3, 1, 3);
	l->remove_rect(b);
	l->dump();
    delete a;
    delete b;
    delete l;
}

#endif
