#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <X11/keysym.h>
#include <string.h>
#include "wtb.h"
#include "text.h"
#include "lod.h"
#include "x_util.h"
#include "compatible.h"
#include "kanji.h"
#include "LODRectList.h"
#include "LODWindow.h"
#include "SelectWindow.h"
#include "MSGWindow.h"
#include "MapWindow.h"
#include "MainWindow.h"

Display* dis;  // Default Display
int scr;  // Default Screen
Window rootwin;
int screen_depth;  // screen depth
GC gc;  // utility gc

// ѥåȤ
unsigned char pal[] = {
	0x00, 0x00, 0x00, 
	0x8f, 0x8f, 0x8f, 
	0xcf, 0xcf, 0xcf, 
	0xcf, 0x8f, 0x6f, 
	0xff, 0xaf, 0x8f, 
	0xff, 0xcf, 0xaf, 
	0x00, 0x8f, 0x00, 
	0x00, 0xbf, 0x00, 
	0xdf, 0xcf, 0x00, 
	0xff, 0xef, 0x00, 
	0xbf, 0x00, 0x00, 
	0xff, 0x00, 0x00, 
	0x00, 0x00, 0x00, 
	0x00, 0x00, 0xbf, 
	0x00, 0x00, 0xff, 
	0xff, 0xff, 0xff, 
};

unsigned long palpix[16];  // ΥѥåȤ˴Ťpixel᤿

int cantgo;
int area_chars, chars;
int map_x, map_y;

unsigned char *chmap=NULL;
unsigned char *inf=NULL;
unsigned char *level=NULL;

Pixmap* map_chars = NULL;
Pixmap* chr_chars;
Pixmap* chr_masks;

int mx, my;  // κɸ
int lx, ly;  // κɸ
int dx, dy;
int stairs;  // ʤο
int warps;  // ץݥȤο
int treasures;  // Ȣο
int mens;  // NPCο
Man* man;  // NPC
Warp* warp;  // ץݥ
Treasure* treasure;  // Ȣ
Stair* stair;  // 
Player player;  // ץ쥤䡼
char bgm_file[256];  // bgmե̾
int drop_flag = 3;  // typeΥġϼΤƤʤ
int g_mode = 1;  // 0: 1:
int px, py;  // ʥݥ(ޥå)
Pixmap waku[3][3];  // WindowɽΤ
int user_v; // 桼θ
clock_t interval = CLOCKS_PER_SEC/5;

int tools = ALL_TOOLS;
Tool tool_list[ALL_TOOLS] = {
	{"null", 0, 0, 0, 0},
	{"", 1, 0, 10, 4},
	{"̤", 2, 0, 10, 5},
	{"η", 1, 0, 75, 10},
	{"γ", 2, 0, 90, 8},
	{"ν", 3, 0, 65, 2},
	{"η", 1, 0, 150, 15},
	{"γ", 2, 0, 180, 16},
	{"ν", 3, 0, 120, 4},
	{"η", 1, 0, 400, 20},
	{"γ", 2, 0, 450, 24},
	{"ν", 3, 0, 350, 6},
	{"", 0, 10, 10, 0},
	{"ǭΤҤ", 0, 11, 100, 0},
	{"إإ", 0, 12, 50, 0},
	{"", 0, 13, 100, 0},
	{"إθ", 4, 14, 0, 0},
	{"إ", 4, 0, 0, 0},
	{"ΤĤ", 4, 0, 0, 0},
	{"ξ", 4, 0, 0, 0},
	{"ο", 4, 0, 0, 0},
	{"إ쥤䡼", 5, 16, 0, 50},
	{"ƥȤη", 1, 0, 10000, 45},
	{"ƥȤγ", 2, 0, 10000, 35},
	{"ƥȤν", 3, 0, 10000, 9},
	{"̹Ծ", 0, 0, 2, 0},
	{"η", 1, 0, 700, 25},
	{"γ", 2, 0, 1000, 32},
	{"ν", 3, 0, 650, 8},
	{"η", 1, 0, 1500, 35},
	{"γ", 2, 0, 2000, 40},
	{"ν", 3, 0, 1200, 10},
	{"å", 1, 0, 10, 205},
	{"󤲡", 2, 0, 10000, 150},
	{"󤲡", 3, 0, 10000, 55},
	{"˷", 0, 0, 5000, 0},
	{"줿إ", 0, 0, 2, 0},
};

int max_level = MAX_LEVEL;
int lvl[MAX_LEVEL][7] = {
	// hp	mp	str	def	dex	exp		magic
	{15, 0,  8,  4,  4,      0,  0},
	{25, 5,  10, 6,  8,      4,  1},
	{28, 15, 12, 8,  10,    12,  5},
	{30, 18, 12, 10, 12,    28,  0},
	{35, 20, 16, 10, 14,    52,  0},
	{38, 25, 20, 14, 18,    88,  4},
	{40, 30, 20, 18, 22,   142,  6},
	{45, 32, 22, 18, 26,   223,  0},
	{50, 34, 24, 20, 28,   344,  3},
	{55, 36, 24, 22, 30,   526,  0},
	{60, 38, 28, 24, 32,   799,  2},
	{65, 40, 32, 24, 36,  1209,  0},
	{70, 42, 32, 28, 40,  1721,  0},
	{75, 45, 34, 32, 44,  2361,  0},
	{80, 55, 36, 34, 48,  3161,  7},
	{85, 65, 36, 36, 48,  4161,  0},
	{90, 70, 40, 38, 50,  5411,  0},
	{95, 75, 44, 42, 50,  6973,  0},
	{90, 80, 48, 46, 50,  8926,  0},
	{100,100,50, 50, 50, 11367, 0},
};

int monsters = MONSTERS;
int monster_list[MONSTERS][8] = {
// hp, mp, ap, ac, dex, gld, exp, itm, name
	{8, 0, 9, 5, 4, 1, 1, 0},
	{10, 0, 12, 8, 5, 8, 1, 0}, 
	{15, 0, 14, 8, 6, 2, 2, 12}, 
	{23, 0, 11, 15, 13, 40, 2, 0}, 
	{20, 4, 19, 12, 9, 8, 3, 12}, 
	{17, 4, 20, 9, 10, 5, 3, 0}, 
	{25, 4, 32, 15, 13, 10, 8, 14}, 
	{50, 8, 28, 4, 11, 10, 12, 0}, 
	{28, 8, 32, 60, 12, 10, 16, 0}, 
	{25, 8, 36, 18, 14, 80, 22, 0}, 
	{55, 8, 47, 45, 10, 10, 20, 0}, 
	{35, 8, 51, 28, 19, 15, 20, 0}, 
	{45, 8, 43, 25, 15, 15, 30, 36}, 
	{40, 8, 48, 49, 22, 10, 35, 36}, 
	{50, 8, 55, 60, 21, 20, 80, 36}, 
	{45, 16, 45, 45, 20, 100, 37, 36}, 
	{55, 16, 60, 35, 20, 30, 40, 36}, 
	{70, 16, 49, 37, 18, 35, 50, 12}, 
	{60, 16, 55, 49, 19, 40, 60, 35}, 
	{80, 16, 50, 60, 24, 45, 160, 15}, 
	{98, 16, 67, 40, 20, 50, 70, 35}, 
	{50, 20, 60, 46, 25, 200, 80, 15}, 
	{60, 20, 63, 50, 20, 60, 85, 15}, 
	{80, 20, 68, 55, 24, 40, 90, 34}, 
	{90, 20, 85, 40, 30, 800, 200, 35}, 
	{100, 32, 69, 60, 32, 100, 320, 33}, 
	{135, 32, 85, 40, 32, 120, 530, 32}, 
	{300, 8, 40, 20, 20, 500, 1, 0}, 
	{500, 40, 50, 20, 20, 1, 1, 0}, 
};

char *monster_name[MONSTERS] = {
	"إإ",
	"߶̤Ф",
	"Υߡ",
	"߶̤Ф",
	"ΤĤΥˡ",
	"֤Υإإ",
	"ߡ˼",
	"",
	"إإƳ",
	"߶̤Ф",
	"֤Υ",
	"ѥإإ",
	"ᥭࡼߥ",
	"Ƴ",
	"°إإ",
	"߶̤Ф",
	"ѥ",
	"Ŵإإ",
	"ᥭѥ",
	"°",
	"",
	"߶̤Ф",
	"Ф쥨",
	"Ŵ奲",
	"߶̤Ф",
	"Фꥨ",
	"",
	"ȥ",
	"إ顼", 
};

int towns = 3;
Town town[3] = {
	{28, 83, "֥"},
	{60, 47, "饤"},
	{40, 20, "˥"}
//	{61, 40, "˥"}  // ŪⲦξ
};

int enter[100], main_enter[100], enters, main_enters;
short code[10000];

Monster monster;
int in_battle = 0;  // Ʈ?
int file;  // եֹ

// ץ쥤䡼¤Τν
void init_player(char* name)
{
	int i;

	strcpy(player.name, name);
	player.use = 1;
	player.level = 1;
	player.hp = 15;
	player.mp = 3;
	player.str = 8;
	player.def = 3;
	player.dex = 3;
	player.hp_max = 15;
	player.mp_max = 3;
	player.ap = 8;
	player.ac = 3;
	player.gold = 100;
	player.exp = 0;
	player.tool[0] = 2;
	player.tool[1] = 3;
	for(i=2; i<MAX_USER_TOOLS; i++) {
		player.tool[i] = 0;
	}
	for(i=0; i<MAX_USER_TOOLS; i++) {
		player.equip[i] = 0;
	}
	for(i=0; i<FLAGS; i++) {
		player.flags[i] = 0;
	}
	for(i=0; i<MAGICS; i++) {
		player.magic[i] = 0;
	}
	for(i=0; i<ATS; i++) {
		player.at[i] = 0;
	}
	for(i=0; i<TREASURES/8; i++) {
		player.treas[i] = 0;
	}
	drop_flag = 3;
	mx = 29;
	my = 83;
}


void disp_inf_all()
{
	map->disp_inf_all();
}



void flash()
{
	map->flash();
}


void red_flash()
{
	map->red_flash();
}



void gload_at(char* fname, int x, int y)
{
	int i, p, ext_x, ext_y, ext_w, ext_h;
	char name[80];
	char buf[80];
	char path[256];
	Pixmap pm;

	if (fname[0]==0) return;
	ext_x = x;
	ext_y = y;
	p = strlen(fname) - 1;
	for(i=strlen(fname) - 1; i>=0; i--) {
		if (fname[i]=='.') break;
	}
	if (i<0) return;
	strncpy(name, fname, i);
	name[i] = 0;
	sprintf(buf, "%s.wtb", name);
	make_path(path, buf);
	if (loadWTB(&pm, rootwin, path, &ext_w, &ext_h)==0) {
		map->set_ext_pm(pm, ext_x, ext_y, ext_w, ext_h);
	}
}


void gload_at_wipe(char* fname, int x, int y)
{
	int i, p, ext_x, ext_y, ext_w, ext_h;
	char name[80];
	char buf[80];
	char path[256];
	Pixmap pm;

	if (fname[0]==0) return;
	ext_x = x;
	ext_y = y;
	p = strlen(fname) - 1;
	for(i=strlen(fname) - 1; i>=0; i--) {
		if (fname[i]=='.') break;
	}
	if (i<0) return;
	strncpy(name, fname, i);
	name[i] = 0;
	sprintf(buf, "%s.wtb", name);
	make_path(path, buf);
	if (loadWTB(&pm, rootwin, path, &ext_w, &ext_h)==0) {
		map->set_ext_pm_wipe(pm, ext_x, ext_y, ext_w, ext_h);
	}
}


void
flush_events()
{
    XEvent ev;
	while (XCheckMaskEvent(dis, KeyPressMask | ButtonPressMask, &ev));
}

int main(void)
{
    Window win;
    XSetWindowAttributes att;
    XEvent ev;
	int num, i, j, ret;
	Pixmap pp;
	int width, height;
	clock_t last_clk;
	int f;
	char path[256];
	MainWindow* main_win;
	
	dis = XOpenDisplay(NULL);  // displayΥץ
	if(dis==NULL) {
		fprintf(stderr, "Can't Open Display\n");
		exit(1);
	}
	scr = DefaultScreen(dis);
	rootwin = DefaultRootWindow(dis);
	screen_depth = DefaultDepth(dis, scr);
	printf("screen_depth = %d\n", screen_depth);

    win = XCreateSimpleWindow(// ɥΥץ
		dis,
		rootwin,
		100, 100,
		640, 400,
		5,
		BlackPixel(dis,scr),
		WhitePixel(dis,scr));
	LODWindow::win = win;
		
    att.backing_store = WhenMapped;
    XChangeWindowAttributes(dis, win, CWBackingStore, &att);

	XGCValues gv;
	
	gv.graphics_exposures = False;
	gc = XCreateGC(dis, win, GCGraphicsExposures, &gv);
	XStoreName(dis, win, "Light Of Dungeon");
    XSelectInput(dis, win, ExposureMask | ButtonPressMask | KeyPressMask);
    XMapWindow(dis, win);
	XFlush(dis);

	// ѥåȤpixelƤ
	for(i=0; i<16; i++) {
		palpix[i] = alloc_color(pal[i*3 + 0], pal[i*3 + 1], pal[i*3 + 2]);
	}

	init_event();
	load_chars(&num);
	map_load("main.mpx");
	inf_load("main.inf");
	player_load(0);

	do {
		XNextEvent(dis, &ev);
	} while(ev.type!=Expose);

	make_path(path, "window.wtb");
	loadWTBWithPal(&pp,
				   win, path, &width, &height, pal, 48);
	
	for(i=0; i<3; i++) {
		for(j=0; j<3; j++) {
			waku[i][j] = XCreatePixmap(dis, rootwin, 8, 16, screen_depth);
			XCopyArea(dis, pp, waku[i][j], gc, j*8, i*16, 8, 16, 0, 0);
		}
	}
	XFreePixmap(dis, pp);
	
	setup_font();

	main_win = new MainWindow(NULL);
	LODWindow::add_window(main_win);

	XSelectInput(dis, win, ButtonPressMask | KeyPressMask);
	last_clk = clock();

	while(1) {
		f = LOD_EV_NONE;
		if (XCheckMaskEvent(dis, KeyPressMask | ButtonPressMask, &ev)) {
			if(ev.type==KeyPress) {
				f = LOD_EV_KEY;
			}
			else if(ev.type==ButtonPress) {
				f = LOD_EV_MOUSE;
			}
			else if(ev.type==Expose) {
				f = LOD_EV_EXPOSE;
			}
		}
		else if(clock() - last_clk >= interval) {
			last_clk = clock();
			f = LOD_EV_TIMER;
		}
		if (f!=LOD_EV_NONE) {
			ret = LODWindow::exec_event(f, &ev);
			if(ret==ST_BREAKGAME) break;
		}
	}

	setdown_font();
	
	XDestroyWindow(dis, win);
	XCloseDisplay(dis);

    return(0);
}


