#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "x_util.h"
#include "wtb.h"
#include "dib.h"


// ǥå顼ѥå(¿ųդ򤱤뤿)
#define COLOR_ALLOC_STEP 16
static int color_max_alloc = 0;
static int color_num_alloc = 0;
static XColor* color_allocated = NULL;

/*
========================================================================
ǽ: r,g,bͤбpixel֤ͤ
: red,gren,blue = դ뿧
: pixel
­: ϥƥ൬ο֤
      ǥå顼Ķξ硢˲˳դƤ뿧ǤС
	  pixelcolor_allocated¸ƤΤǡ֤
========================================================================
*/
unsigned long alloc_color(unsigned char red,
						  unsigned char green,
						  unsigned char blue)
{
	XColor c, tc;
	unsigned long now, min, near_pix;
	int i;

	// ä顢֤
	if (red==0 && green==0 && blue==0) {
		return BlackPixel(dis,scr);
	}
	// ä顢֤
	if (red==0xff && green==0xff && blue==0xff) {
		return WhitePixel(dis,scr);
	}
	// ʤФ餷֤
	c.red   = ((unsigned short)red) << 8;
	c.green = ((unsigned short)green) << 8;
	c.blue  = ((unsigned short)blue) << 8;
	if (screen_depth <= 8) {
		// indexed顼ʤ餹Ǥ˴Ƥ륫顼åƤ
		// Ͽ٤ȽǤƤϤϤʤɡġ
		for(i=0; i<color_num_alloc; i++) {
			if (color_allocated[i].red==c.red
				&& color_allocated[i].green==c.green
				&& color_allocated[i].blue==c.blue) {
				return color_allocated[i].pixel;
			}
		}
	}
	// ϿѤǤϤʤ뤤ϡޤȤʥ顼֤ä
	if (XAllocColor(dis, DefaultColormap(dis, scr), &c)==0) {
		// դԤξϤʤ٤ᤤõ
		fprintf(stderr,
				"ɤ褦? դ %02x %02x %02x\n",
				red, green, blue);
		min = 0xffffffff;
		for(i=0; i<(1<<screen_depth); i++) {
			tc.pixel = i;
			XQueryColor(dis, DefaultColormap(dis, scr), &tc);
			now =
				(c.red - tc.red)*(c.red - tc.red) +
				(c.green - tc.green)*(c.green - tc.green) +
				(c.blue - tc.blue)*(c.blue - tc.blue);
			if (now < min) {
				min = now;
				near_pix = i;
				if (now==0) break;  // פ
			}
		}
		c.pixel = near_pix;
	}
	// դ(indexed顼ξΤ)Ͽ򤷤Ƥ
	if (screen_depth <= 8) {
		if (color_num_alloc==color_max_alloc) {
			// ơ֥礭ɬפޤ
			XColor* new_table;
			
			new_table = (XColor*)malloc(
				sizeof(XColor)*(color_max_alloc + COLOR_ALLOC_STEP));
			for(i=0; i<color_num_alloc; i++) {
				new_table[i] = color_allocated[i];
			}
			free(color_allocated);
			color_allocated = new_table;
			color_max_alloc += COLOR_ALLOC_STEP;
		}
		color_allocated[color_num_alloc++] = c;
	}
	return c.pixel;
}



/*
========================================================================
ǽ: WTBեΥ
: pm = ֤ͤPixmap
	  vis = Drawable(windowʤ)
	  fname = ɤե̾
	  width = ɤե
	  height = ɤեι⤵
: 0, Ԥξ-1
­: 
========================================================================
*/
int loadWTB(Pixmap* pm, Drawable vis, char* fname, int* width, int* height)
{
	unsigned char rgb[256*3];
	int color_used[256];
	unsigned int pixels[256];
	unsigned char* buf;
	int i, x, y, deapth;
	GC gc;

    gc = XCreateGC(dis, DefaultRootWindow(dis), 0, 0);
	if (WTBInfo(fname, width, height, &deapth, (char*)rgb)!=0) {
		fprintf(stderr, "Can't open '%s'\n", fname);
		XFreeGC(dis, gc);
		return -1;
	}
	buf = (unsigned char*)malloc(*width * *height);
	WTBLoad(fname, buf, *width, *height, *width, 0, 0, NULL);
	for(i=0; i<256; i++) {
		color_used[i] = 0;
	}
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			color_used[buf[y* *width + x]] = 1;
		}
	}
	for(i=0; i<256; i++) {
		if (color_used[i]) {
			pixels[i] = alloc_color(rgb[i*3 + 0], rgb[i*3 + 1], rgb[i*3 + 2]);
		}
	}
	*pm = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *pm, gc, x, *height-y-1);
		}
	}
	free(buf);
	XFreeGC(dis, gc);
	return 0;
}

/*
========================================================================
ǽ: WTBեΥ(Υޤ)
: pm = ֤ͤPixmap
      mono = ֤ͤPixmap(Υ)
	  vis = Drawable(windowʤ)
	  fname = ɤե̾
	  width = ɤե
	  height = ɤեι⤵
: 0, Ԥξ-1
­: rgbͤΤbͤȤäΥޤ
      Ϥȵٷ׻ȤʤʤΤɡʤǤ
	  빽뤫Ի׵Ĥ
========================================================================
*/
int loadWTBWithMono(Pixmap* pm,
					Pixmap* mono,
					Drawable vis,
					char* fname, int* width, int* height)
{
	unsigned char rgb[256*3];
	int color_used[256];
	unsigned int pixels[256];
	unsigned char* buf;
	int i, x, y, deapth;
	GC gc;
	
    gc = XCreateGC(dis, DefaultRootWindow(dis), 0, 0);
	if (WTBInfo(fname, width, height, &deapth, (char*)rgb)!=0) {
		fprintf(stderr, "Can't open '%s'\n", fname);
		XFreeGC(dis, gc);
		return -1;
	}
	buf = (unsigned char*)malloc(*width * *height);
	WTBLoad(fname, buf, *width, *height, *width, 0, 0, NULL);
	for(i=0; i<256; i++) {
		color_used[i] = 0;
	}
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			color_used[buf[y* *width + x]] = 1;
		}
	}
	for(i=0; i<256; i++) {
		if (color_used[i]) {
			pixels[i] = alloc_color(rgb[i*3 + 0], rgb[i*3 + 1], rgb[i*3 + 2]);
		}
	}
	*pm = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *pm, gc, x, *height-y-1);
		}
	}
	for(i=0; i<256; i++) {
		if (color_used[i]) {
			// rgbbѤƥΥˤ
			pixels[i] = alloc_color(rgb[i*3 + 1], rgb[i*3 + 1], rgb[i*3 + 1]);
		}
	}
	*mono = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *mono, gc, x, *height-y-1);
		}
	}
	free(buf);
	XFreeGC(dis, gc);
	return 0;
}


/*
========================================================================
ǽ: WTBեΥ(åդ)
: pm = ֤ͤPixmap
      clip = ֤ͤPixmapå
	  vis = Drawable(windowʤ)
	  fname = ɤե̾
	  width = ɤե
	  height = ɤեι⤵
	  clip_color = åפ˻Ȥ
: 0, Ԥξ-1
­: 
========================================================================
*/
int loadWTBWithClip(Pixmap* pm,
					Pixmap* clip,
					Drawable vis, char* fname, int* width, int* height,
					int clip_color)
{
	unsigned char rgb[256*3];
	int color_used[256];
	unsigned int pixels[256];
	unsigned char* buf;
	int i, x, y, deapth;
	GC gc;
	
    gc = XCreateGC(dis, DefaultRootWindow(dis), 0, 0);
	if (WTBInfo(fname, width, height, &deapth, (char*)rgb)!=0) {
		fprintf(stderr, "Can't open '%s'\n", fname);
		XFreeGC(dis, gc);
		return -1;
	}
	buf = (unsigned char*)malloc(*width * *height);
	WTBLoad(fname, buf, *width, *height, *width, 0, 0, NULL);
	for(i=0; i<256; i++) {
		color_used[i] = 0;
	}
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			color_used[buf[y* *width + x]] = 1;
		}
	}
	for(i=0; i<256; i++) {
		if (color_used[i]) {
			pixels[i] = alloc_color(rgb[i*3 + 0], rgb[i*3 + 1], rgb[i*3 + 2]);
		}
	}
	*pm = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *pm, gc, x, *height-y-1);
		}
	}
	XFreeGC(dis, gc);

	*clip = XCreatePixmap(dis, vis, *width, *height, 1);
	XCreateGC(dis, *clip, 0, 0);
	XSetForeground(dis, gc, 0);
	XFillRectangle(dis, *clip, gc, 0, 0, *width, *height);
	XSetForeground(dis, gc, 1);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			if (buf[y* *width + x]!=clip_color) {
				XDrawPoint(dis, *clip, gc, x, *height-y-1);
			}
		}
	}
	XFreeGC(dis, gc);
	
	free(buf);
	return 0;
}


/*
========================================================================
ǽ: WTBեΥ(ѥåȤϻΤΤˤ)
: pm = ֤ͤPixmap
	  vis = Drawable(windowʤ)
	  fname = ɤե̾
	  width = ɤե
	  height = ɤեι⤵
	  rgb = ѥå
	  colnum = 顼
: 0, Ԥξ-1
­: 
========================================================================
*/
int loadWTBWithPal(Pixmap* pm,
				   Drawable vis, char* fname, int* width, int* height,
				   unsigned char*rgb, int colnum)
{
	int color_used[256];
	unsigned int pixels[256];
	unsigned char* buf;
	int i, x, y, deapth;
	GC gc;
	
    gc = XCreateGC(dis, DefaultRootWindow(dis), 0, 0);
	if (WTBInfo(fname, width, height, &deapth, NULL)!=0) {
		fprintf(stderr, "Can't open '%s'\n", fname);
		XFreeGC(dis, gc);
		return -1;
	}
	buf = (unsigned char*)malloc(*width * *height);
	WTBLoad(fname, buf, *width, *height, *width, 0, 0, NULL);
	for(i=0; i<colnum; i++) {
		color_used[i] = 0;
	}
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			color_used[buf[y* *width + x]] = 1;
		}
	}
	for(i=0; i<colnum; i++) {
		if (color_used[i]) {
			pixels[i] = alloc_color(rgb[i*3 + 0], rgb[i*3 + 1], rgb[i*3 + 2]);
		}
	}
	*pm = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *pm, gc, x, *height-y-1);
		}
	}
	free(buf);
	XFreeGC(dis, gc);
	return 0;
}


/*
========================================================================
ǽ: DIBեΥ
: pm = ֤ͤPixmap
	  vis = Drawable(windowʤ)
	  fname = ɤե̾
	  width = ɤե
	  height = ɤեι⤵
: 0, Ԥξ-1
­: 
========================================================================
*/
int loadDIB(Pixmap* pm, Drawable vis, char* fname, int* width, int* height)
{
	unsigned char rgb[256*3];
	int color_used[256];
	unsigned int pixels[256];
	unsigned char* buf;
	int i, x, y, deapth;
	GC gc;

    gc = XCreateGC(dis, DefaultRootWindow(dis), 0, 0);
	if (DIBInfo(fname, width, height, &deapth, (char*)rgb)!=0) {
		fprintf(stderr, "Can't open '%s'\n", fname);
		XFreeGC(dis, gc);
		return -1;
	}
	buf = (unsigned char*)malloc(*width * *height);
	DIBLoad(fname, buf, *width, *height, *width, 0, 0, NULL);
	for(i=0; i<256; i++) {
		color_used[i] = 0;
	}
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			color_used[buf[y* *width + x]] = 1;
		}
	}
	for(i=0; i<256; i++) {
		if (color_used[i]) {
			pixels[i] = alloc_color(rgb[i*3 + 0], rgb[i*3 + 1], rgb[i*3 + 2]);
		}
	}
	*pm = XCreatePixmap(dis, vis, *width, *height, screen_depth);
	for(y=0; y<*height; y++) {
		for(x=0; x<*width; x++) {
			XSetForeground(dis,gc,pixels[buf[y * *width + x]]);
			XDrawPoint(dis, *pm, gc, x, *height-y-1);
		}
	}
	free(buf);
	XFreeGC(dis, gc);
	return 0;
}

